-- string.lower(yy)
-- MatchingPhrases

local greetingMatch = {"Hallo","Hui","Huhu","halo","hallo","hai","wuhu","boing","hi","halöööö","wuihu"}
local farewellMatch = {"bye", "tschüss", "tschau", "bis morgen", "bis dann", "bb", "bubu", "hau rein"}
local thanksMatch = {"thx", "ty", "danke", "thanks", "danke schön"}
local reMatch = {"re", "wieder da"}
local wbMatch = {"wb", "welcome back"}
local ggMatch = {"gg", "gg wp", "ggwp", "wp", "stronk"}
-- local playerNameMatch = {"illu"}

-- Responses

local greetingResponse = {"Hallo", "Hui", "Huhu", "halo", "hallo", "hai", "wuhu", "boing", "hi", "halöööö", "wuihu"}
local farewellResponse = {"bye", "tschüss", "tschau", "bis morgen", "bis dann", "bb", "bubu", "hau rein"}
local thanksResponse = {"np", "jo np", "gerne doch", "kein ding", "np brudah", "jo kein ding", "immer doch"}
local reResponse = {"wb", "welcome back"}
local wbResponse = {"thx", "ty", "danke", "thanks", "danke schön"}
local ggResponse = {"easy"}
-- local playerNameResponse = {"KEKW"}
local itemResponse = {
	"Pog",
	"HYPE",
	"WoW wo bekommt man das?",
	"Auch endlich mal bekommen?",
	"Nice, Aciz ist stolz auf dich!"
}

local achievementReponse = {
		"das ist tolle Arbeit Freunde",
		"Ich dreh durch, Klasse Typ",
		"Eher nicht so schwer, {name}" , 
		"Gut gemacht {name}", 
		"gz  {name}", 
		"Ein toller Erfolg, {name}",
		"gz", 
		"gratz", 
		"GZ {name}", 
		"Puh.. {name}, Holla die Waldfee!",
		"{name} ich will ein Kind von dir!",
		"Hut ab! {name}",
		"Dieser {name} geht ab!",
		"Sheesh, {name}!",
		"gratz {name}", 
		"Ich bin stolz auf dich, {name}!",
		"Fantastisch, {name}!",
		"Klasse!",
		"Spitzenmäßig!",
		"Spitze!",
		"Gönn ich dir, {name}",
		"Cool {name}, hole ich mir auch!",
		"Geilomatic",
		"Sickadelic",
		"Beste YA, {name}",
		"Beste YA",
		"Super, {name}",
		"Super",
		"Teuflisch! {name}",
		"Unglaublich!",
		"BOOM !",
		"Bumm Bumm {name}",
		"#achievement",
		"#geilertyp",
		"uff hartes achievement",
		"{name} WHO?",
		"{name}, rasiert euch mit Shampoo"
}

-- Frame

local NotValidSocial = CreateFrame("frame")
NotValidSocial:SetScript("OnEvent", function(self, event, ...) self[event](self, ...)
						end)

-- Settings

local respondToAchievements = true
local respondToPhrases = true
local delayBetweenMessages = 5

if (respondToAchievements) then NotValidSocial:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT"); end
if (respondToPhrases) then NotValidSocial:RegisterEvent("CHAT_MSG_GUILD"); end

-- Checks

local lastAchievementAutoResponse = 0
local lastPhraseAutoResponse = 0

-- EventHandler

function NotValidSocial:CHAT_MSG_GUILD_ACHIEVEMENT(...)
	if (lastAchievementAutoResponse < time())then
		local arg = {...}
		local msg = "gz"
		local name = arg[2]
		local msg = achievementReponse[math.random(#achievementReponse)]
		

		local index = string.find(name,"-")
		if (index ~= nil) then 
			name = string.sub(name,0,index-1)
		end

		if (name ~= UnitName("player"))then
			msg = string.gsub(msg, "{name}", name)
			SendChatMessage(msg,"GUILD")
		end
		lastAchievementAutoResponse = time() + delayBetweenMessages
	end
end

function NotValidSocial:CHAT_MSG_GUILD(...)
	local msg = ...
	local senderName = select(2,...)


	local index = string.find(senderName,"-")
	if (index ~= nil) then 
		senderName = string.sub(senderName,0,index-1)
	end
	msg = string.lower(msg)
	
	if (senderName == UnitName("player")) then
		lastPhraseAutoResponse = time()
		return 
	end

	if (lastPhraseAutoResponse > time()) then
		return
	end

	-- ItemLinked

	if ( string.match(msg, 'item:(%d+):') ~= nil ) then
		SendChatMessage(itemResponse[math.random(#itemResponse)],"GUILD")
		lastPhraseAutoResponse = time() + delayBetweenMessages
		return			
	end

	-- GG

	for i = 1, #ggMatch do
		if (string.find(string.gsub(msg,"(.*)"," %1 "), "[^%a]"..ggMatch[i].."[^%a]"))then
			SendChatMessage(ggResponse[math.random(#ggResponse)],"GUILD")
			lastPhraseAutoResponse = time() + delayBetweenMessages
			return
		end
	end

	-- RE

	for i = 1, #reMatch do
		if (string.find(string.gsub(msg,"(.*)"," %1 "), "[^%a]"..reMatch[i].."[^%a]"))then
			SendChatMessage(reResponse[math.random(#reResponse)],"GUILD")
			lastPhraseAutoResponse = time() + delayBetweenMessages
			return
		end
	end

	-- WB

	for i = 1, #wbMatch do
		if (string.find(string.gsub(msg,"(.*)"," %1 "), "[^%a]"..wbMatch[i].."[^%a]"))then
			SendChatMessage(wbResponse[math.random(#wbResponse)],"GUILD")
			lastPhraseAutoResponse = time() + delayBetweenMessages
			return
		end
	end

	-- Greetings

	for i = 1, #greetingMatch do
		if (string.find(string.gsub(msg,"(.*)"," %1 "), "[^%a]"..greetingMatch[i].."[^%a]"))then
			SendChatMessage(greetingResponse[math.random(#greetingResponse)],"GUILD")
			lastPhraseAutoResponse = time() + delayBetweenMessages
			return
		end	
	end

	-- Farewell

	for i = 1, #farewellMatch do
		if (string.find(string.gsub(msg,"(.*)"," %1 "), "[^%a]"..greetingMatch[i].."[^%a]"))then
			SendChatMessage(farewellResponse[math.random(#farewellResponse)],"GUILD")
			lastPhraseAutoResponse = time() + delayBetweenMessages
			return
		end	
	end

	-- Thanks

	for i = 1, #thanksMatch do
		if (string.find(string.gsub(msg,"(.*)"," %1 "), "[^%a]"..thanksMatch[i].."[^%a]"))then
			SendChatMessage(thanksResponse[math.random(#thanksResponse)],"GUILD")
			lastPhraseAutoResponse = time() + delayBetweenMessages
			return
		end	
	end
	
	
end
